#include <iostream>
#include <cstdio>
#include <windows.h>
#include <WinBase.h>
#include <io.h>

using namespace std;

inline unsigned int decodeSize(unsigned int v)
{
    unsigned int lba = ((v >> 0x13) & 0xFFFF) << 8;
    return lba;
}


unsigned int encodeLBA(unsigned int lba)
{
    unsigned int v = (lba & 0xFFFF) << 0x16;
    //unsigned int v = (lba << 11);
    return v;
}

char* decodeName(unsigned int v1, unsigned int v2, char* name)
{
    v1 >>= 4;
    int i;
    for(i = 0; i < 4 && v1 != 0; i++)
    {
        name[i] = (v1 & 0x3F) + 0x20;
        v1 >>= 6;
    }
    v2 &= 0xFFFFFF;
    unsigned int l = i + 4;
    for(; i < l && v2 != 0; i++)
    {
        name[i] = (v2 & 0x3F) + 0x20;
        v2 >>= 6;
    }
    name[i] = 0;
    return name;
}

unsigned int encodeName(char* name)
{
    unsigned int v = 0;
    for(int i = 0; i < 4; i++)
    {
        v |= (name[i] - 0x20) & 0x3F;
        v <<= 6;
    }
    return v << 4;
}

struct Rec
{
    unsigned int a;
    unsigned int b;
    unsigned int c;
};

const char* exts[] =
    {
        ".TIM", ".VAB", ".BIN", ".DMS",
        ".ANM", ".PLM", ".IPD", ".ILM",
        ".TMD", ".DAT", ".KDT", ".CMP",
        ".TXT", "", "", ""
    };

const char* dirs[] =
    {
        "\\1ST\\",   "\\ANIM\\",  "\\BG\\",    "\\CHARA\\",
        "\\ITEM\\",  "\\MISC\\",  "\\SND\\",   "\\TEST\\",
        "\\TIM\\",   "\\VIN\\",   "\\VIN2\\",  "\\VIN3\\",
        "\\VIN4\\",  "\\VIN5\\",  "\\XA\\",    "\\"
    };

void ForceDirectories(const char *dir)
{
    char tmp[MAX_PATH];
    char *p = NULL;
    size_t len;

    snprintf(tmp, sizeof(tmp), "%s",dir);
    len = strlen(tmp);
    if(tmp[len - 1] == '\\')
    tmp[len - 1] = 0;
    for(p = tmp + 1; *p; p++)
    if(*p == '\\') {
        *p = 0;
        CreateDirectory(tmp, NULL);
        //mkdir(tmp, S_IRWXU);
        *p = '\\';
    }
    //mkdir(tmp, S_IRWXU);
    CreateDirectory(tmp, NULL);
}

bool DirectoryExists(const char *dir)
{
    return (access(dir, 0) == 0);
}

void extract(Rec* rec, int count, const char *in_file, const char *out_dir)
{
    char path[MAX_PATH];
    char name[16];
    unsigned int offset = 0, size;
    void* buf = malloc(1024*1024*2);

    strcpy(path, out_dir);
    if(!DirectoryExists(path))
    {
        ForceDirectories(path);
    }
    strcat(path, "\\list.txt");
    FILE* list = fopen(path, "w");

    FILE *f = fopen(in_file, "rb"), *wf;

    while(count > 0)
    {
        strcpy(path, out_dir);
        strcat(path, dirs[rec->b & 0x0F]);
        if(!DirectoryExists(path))
        {
           ForceDirectories(path);
        }
        decodeName(rec->b, rec->c, name);
        cout << name << exts[rec->c >> 24] << "  " << (void*)rec->a <<endl;
        strcat(path, name);
        strcat(path, exts[rec->c >> 24]);

        size = decodeSize(rec->a);
        fseek(f, offset, SEEK_SET);
        if(size > 0) fread(buf, size, 1, f);

        wf = fopen(path, "wb");
        if(size > 0) fwrite(buf, size, 1, wf);
        fclose(wf);

        fprintf(list, "%8.8X %8.8X %s%s%s\n", offset, size, dirs[rec->b & 0x0F], name, exts[rec->c >> 24]);

        count--;
        rec++;
        offset += ((size + 0x7FF) / 0x800) * 0x800;
    }
    fclose(f);
    fclose(list);
    free(buf);
}

int main()
{
    unsigned int lba, v;
    char name[8];
    unsigned char buf[0x10000];
    //cout << (void*)encodeLBA(0x8CD2) << endl;
    //cout << (void*)decodeLBA(0x1872B4) << endl;
    //cout << decodeName(0x336, name) << endl;
    /*

    FILE *f = fopen("F:\\SLES_015.14", "rb");
    fseek(f, 0xB8FC, SEEK_SET);
    fread(buf, 12, 2310, f);
    fclose(f);
    Rec *rec = (Rec*)buf;
    extract(rec, 2310, "D:\\_job\\SH1\\SILENT_OR", "F:\\Temp\\SH1\\EUR");

*/
/*
    FILE *f = fopen("F:\\Temp\\SH1\\USA\\SLUS_007.07", "rb");
    fseek(f, 0xB850, SEEK_SET);
    fread(buf, 12, 2072, f);
    fclose(f);
    Rec *rec = (Rec*)buf;
    extract(rec, 2072, "F:\\Temp\\SH1\\USA\\SILENT", "F:\\Temp\\SH1\\USA");
*/
    FILE *f = fopen("F:\\Temp\\SH1\\EUR\\SLES_015.14", "rb");
    fseek(f, 0xB8FC, SEEK_SET);
    fread(buf, 12, 2310, f);
    fclose(f);
    Rec *rec = (Rec*)buf;
    extract(rec, 2310, "D:\\_job\\SH1\\SILENT", "F:\\Temp\\SH1\\RUS");
/*
    unsigned int offset = 0, size;
    for(int i = 0; i < 2310; i++)
    {
        size = decodeSize(rec->a);

        cout << dirs[rec->b & 0x0F] << decodeName(rec->b, rec->c, name) << exts[rec->c >> 24]
        << "\toffset: " << (void*)offset << ", size: "
        << (void*)size << "  " << endl;
        rec++;
        offset += ((size + 0x7FF) / 0x800) * 0x800;
    }
    */
    return 0;
}
